/// <reference types="react" />
import Tweezer from 'tweezer.js';
declare enum Direction {
    Up = 0,
    Down = 1,
    None = 2
}
interface ScrollState {
    currentIndex: number;
    currentOffset: number;
    targetOffset: number;
    timeoutID: number;
    direction: Direction;
    directionStart: number;
    animation: Tweezer | null;
}
interface UseScrollSnapProps {
    ref: React.RefObject<HTMLElement>;
    duration?: number;
    isArrowKeysEnabled?: boolean;
    isDirectionEnabled?: boolean;
}
interface UseScrollSnapReturn {
    state: React.RefObject<ScrollState>;
    goto: (index: number) => void;
}
declare function useScrollSnap({ ref: elementRef, duration, isArrowKeysEnabled, isDirectionEnabled, }: UseScrollSnapProps): UseScrollSnapReturn;
export default useScrollSnap;
